package qdbm;

class Villa implements Iterator < {key : String, value : String} > {
	private var __c : Void;
	private var __s : String;
	private var __e : String;
	private var __n : Bool;
	private var __forward : Bool;
	private var __func : String -> String -> Int;
	private var __count : Int;
	
	public static function VL_CMPLEX (str1 : String, str2 : String) : Int {
		return villa_VL_CMPLEX(untyped str1.__s, untyped str2.__s);
	}
	
	public static function VL_CMPINT (str1 : String, str2 : String) : Int {
		return villa_VL_CMPINT(untyped str1.__s, untyped str2.__s);
	}
	
	public static function VL_CMPNUM (str1 : String, str2 : String) : Int {
		return villa_VL_CMPNUM(untyped str1.__s, untyped str2.__s);
	}
	
	public static function VL_CMPDEC (str1 : String, str2 : String) : Int {
		return villa_VL_CMPDEC(untyped str1.__s, untyped str2.__s);
	}



	private function new(c) {
		this.__c = c;
		this.__forward = true;
		this.__s = null;
		this.__e = null;
		this.__n = true;
		this.__count = 0;
	}

	public static function open(path : String, writable : Bool) : qdbm.Villa {
		return new qdbm.Villa(villa_open(untyped path.__s, writable));
	}
	
	public static function remove(path : String) : Bool {
		return villa_remove(untyped path.__s);
	}

	public function close() : Bool {
		return villa_close(this.__c);
	}
	
	public function sync() : Bool {
		return villa_sync(this.__c);
	}
	
	public function optimize() : Bool {
		return villa_optimize(this.__c);
	}

	public function get(key : String) : String {
		var x = villa_get(this.__c, untyped key.__s);
		return if(x == null) null else new String(x);
	}
	
	public function put(key : String, value : String) : Bool {
		return villa_put(this.__c, untyped key.__s, untyped value.__s);
	}

	public function curjump(key : String, forward : Bool) : Bool {
		this.__forward = forward;
		return villa_curjump(this.__c, untyped key.__s, forward);
	}

	public function setRange(start : String, end : String, func : String -> String -> Int, forward : Bool) : Bool {

		if(start != null){
			this.curjump(start, forward);
		}else if(forward){
			this.curfirst();
			this.__forward = forward;
		}else{
			this.curlast();
			this.__forward = forward;
		}
		
		this.__s = start;
		this.__e = end;
		this.__n = true;
		this.__func = func;
		this.__count = 0;
		//this.next();
		return true;
	}

	public function hasNext() : Bool {
		var b;
		this.__count++;

		//if (this.__count == 1) return if (this.curkey() == null) false else true;
		
		if (this.__n == false) return false;
		if(this.__count > 1) {
			if (this.__forward) {
				b = villa_curnext(this.__c);
			} else {
				b = villa_curprev(this.__c);
			}
		}else{
			b = if(this.curkey() == null) false else true;
		}
		if(b == false) return false;
		var key = this.curkey();


		if(this.__e != null){
			var f = this.__func(key, this.__e);
			if(this.__forward){
				if (f > 0) b = false;
			}else{
				if (f < 0) b = false;
			}
		}

		this.__n = b;
		return b;
	}
 
	public function next() : {key : String, value : String} {
		var r = {
			key : this.curkey(),
			value : this.curval()
			};

		return r;
	}


	public function begin() : Bool {
		return villa_tranbegin(this.__c);
	}

	public function commit() : Bool {
		return villa_trancommit(this.__c);
	}

	public function abort() : Bool {
		return villa_tranabort(this.__c);
	}

	
	public function curfirst() : Bool {
		return villa_curfirst(this.__c);
	}
	
	public function curlast() : Bool {
		return villa_curlast(this.__c);
	}
	
	public function curnext() : Bool {
		return villa_curnext(this.__c);
	}
	
	public function curprev() : Bool {
		return villa_curprev(this.__c);
	}
	
	public function curkey() : String {
		var x = villa_curkey(this.__c);
		return if(x == null) null else new String(x);
	}
	
	public function curval() : String {
		var x = villa_curval(this.__c);
		return if(x == null) null else new String(x);
	}

	public function curout() : Bool {
		return villa_curout(this.__c);
	}

	public function rnum() : Int {
		return villa_rnum(this.__c);
	}
 


	
	static var villa_open = neko.Lib.load("qdbm","villa_open",2);
	static var villa_remove = neko.Lib.load("qdbm","villa_remove",1);
	static var villa_close = neko.Lib.load("qdbm","villa_close",1);
	static var villa_sync = neko.Lib.load("qdbm","villa_sync",1);
	static var villa_optimize = neko.Lib.load("qdbm","villa_optimize",1);
	static var villa_get = neko.Lib.load("qdbm","villa_get",2);
	static var villa_curjump = neko.Lib.load("qdbm","villa_curjump",3);
	static var villa_curkey = neko.Lib.load("qdbm","villa_curkey",1);
	static var villa_curval = neko.Lib.load("qdbm","villa_curval",1);
	static var villa_curout = neko.Lib.load("qdbm","villa_curout",1);
	static var villa_curnext = neko.Lib.load("qdbm","villa_curnext",1);
	static var villa_curprev = neko.Lib.load("qdbm","villa_curprev",1);
	static var villa_curfirst = neko.Lib.load("qdbm","villa_curfirst",1);
	static var villa_curlast = neko.Lib.load("qdbm","villa_curlast",1);
	static var villa_put = neko.Lib.load("qdbm","villa_put",3);
	static var villa_rnum = neko.Lib.load("qdbm","villa_rnum",1);
	static var villa_tranbegin = neko.Lib.load("qdbm","villa_tranbegin",1);
	static var villa_trancommit = neko.Lib.load("qdbm","villa_trancommit",1);
	static var villa_tranabort = neko.Lib.load("qdbm","villa_tranabort",1);


	static var villa_VL_CMPLEX = neko.Lib.load("qdbm","villa_VL_CMPLEX",2);
	static var villa_VL_CMPINT = neko.Lib.load("qdbm","villa_VL_CMPINT",2);
	static var villa_VL_CMPNUM = neko.Lib.load("qdbm","villa_VL_CMPNUM",2);
	static var villa_VL_CMPDEC = neko.Lib.load("qdbm","villa_VL_CMPDEC",2);

}

